CodecXz.jl
==========

## Installation

```julia
Pkg.add("CodecXz")
```

## Usage

```julia
using CodecXz

# Some text.
text = """
Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean sollicitudin
mauris non nisi consectetur, a dapibus urna pretium. Vestibulum non posuere
erat. Donec luctus a turpis eget aliquet. Cras tristique iaculis ex, eu
malesuada sem interdum sed. Vestibulum ante ipsum primis in faucibus orci luctus
et ultrices posuere cubilia Curae; Etiam volutpat, risus nec gravida ultricies,
erat ex bibendum ipsum, sed varius ipsum ipsum vitae dui.
"""

# Streaming API.
stream = XzCompressorStream(IOBuffer(text))
for line in eachline(XzDecompressorStream(stream))
    println(line)
end
close(stream)

# Array API.
compressed = transcode(XzCompressor, text)
@assert sizeof(compressed) < sizeof(text)
@assert transcode(XzDecompressor, compressed) == Vector{UInt8}(text)
```

This package exports following codecs and streams:

| Codec            | Stream                 |
| ---------------- | ---------------------- |
| `XzCompressor`   | `XzCompressorStream`   |
| `XzDecompressor` | `XzDecompressorStream` |

See docstrings and [TranscodingStreams.jl](https://github.com/bicycle1885/TranscodingStreams.jl) for details.

using CodecXz
using TranscodingStreams: TranscodingStreams
using TestsForCodecPackages
using Test

@testset "Xz Codec" begin
    codec = XzCompressor()
    @test codec isa XzCompressor
    @test occursin(r"^(CodecXz\.)?XzCompressor\(level=\d, check=\d+\)$", sprint(show, codec))
    @test CodecXz.initialize(codec) === nothing
    @test CodecXz.finalize(codec) === nothing

    codec = XzDecompressor()
    @test codec isa XzDecompressor
    @test occursin(r"^(CodecXz\.)?XzDecompressor\(memlimit=\d+, flags=\d+\)$", sprint(show, codec))
    @test CodecXz.initialize(codec) === nothing
    @test CodecXz.finalize(codec) === nothing

    # Generated by `lzma.compress(b"foo")` on CPython 3.5.2.
    data = Vector(b"\xfd7zXZ\x00\x00\x04\xe6\xd6\xb4F\x02\x00!\x01\x16\x00\x00\x00t/\xe5\xa3\x01\x00\x02foo\x00\x00X\x15\xa9{,\xe6,\x98\x00\x01\x1b\x03\x0b/\xb9\x10\x1f\xb6\xf3}\x01\x00\x00\x00\x00\x04YZ")
    @test read(XzDecompressorStream(IOBuffer(data))) == b"foo"
    @test read(XzDecompressorStream(IOBuffer(vcat(data, data)))) == b"foofoo"
    # corrupt data
    data[[1,3,5]] = b"bug"
    @test_throws ErrorException read(XzDecompressorStream(IOBuffer(data)))

    @test XzCompressorStream <: TranscodingStreams.TranscodingStream
    @test XzDecompressorStream <: TranscodingStreams.TranscodingStream

    test_roundtrip_read(XzCompressorStream, XzDecompressorStream)
    test_roundtrip_write(XzCompressorStream, XzDecompressorStream)
    test_roundtrip_lines(XzCompressorStream, XzDecompressorStream)
    test_roundtrip_seekstart(XzCompressorStream, XzDecompressorStream)
    test_roundtrip_transcode(XzCompressor, XzDecompressor)

    @test_throws ArgumentError XzCompressor(level=10)
    @test_throws ArgumentError XzDecompressor(memlimit=0)
end

module CodecXz

export
    XzCompressor,
    XzCompressorStream,
    XzDecompressor,
    XzDecompressorStream

import TranscodingStreams:
    TranscodingStreams,
    TranscodingStream,
    Memory,
    Error,
    initialize,
    finalize,
    splitkwargs
using XZ_jll

include("liblzma.jl")
include("compression.jl")
include("decompression.jl")

end # module

# Compressor Codec
# ================

struct XzCompressor <: TranscodingStreams.Codec
    stream::LZMAStream
    preset::UInt32
    check::Cint
end

function Base.show(io::IO, codec::XzCompressor)
    print(io, summary(codec), "(level=$(codec.preset), check=$(codec.check))")
end

const DEFAULT_COMPRESSION_LEVEL = 6
const DEFAULT_CHECK = LZMA_CHECK_CRC64

"""
    XzCompressor(;level=$(DEFAULT_COMPRESSION_LEVEL), check=LZMA_CHECK_CRC64)

Create an xz compression codec.

Arguments
---------
- `level`: compression level (0..9)
- `check`: integrity check type (`LZMA_CHECK_{NONE,CRC32,CRC64,SHA256}`)
"""
function XzCompressor(;level::Integer=DEFAULT_COMPRESSION_LEVEL, check::Cint=DEFAULT_CHECK)
    if !(0 ≤ level ≤ 9)
        throw(ArgumentError("compression level must be within 0..9"))
    elseif check ∉ (LZMA_CHECK_NONE, LZMA_CHECK_CRC32, LZMA_CHECK_CRC64, LZMA_CHECK_SHA256)
        throw(ArgumentError("invalid integrity check"))
    end
    return XzCompressor(LZMAStream(), level, check)
end

const XzCompressorStream{S} = TranscodingStream{XzCompressor,S} where S<:IO

"""
    XzCompressorStream(stream::IO; kwargs...)

Create an xz compression stream (see `XzCompressor` for `kwargs`).
"""
function XzCompressorStream(stream::IO; kwargs...)
    x, y = splitkwargs(kwargs, (:level, :check))
    return TranscodingStream(XzCompressor(;x...), stream; y...)
end


# Methods
# -------

function TranscodingStreams.initialize(codec::XzCompressor)
    ret = easy_encoder(codec.stream, codec.preset, codec.check)
    if ret != LZMA_OK
        lzmaerror(codec.stream, ret)
    end
    return
end

function TranscodingStreams.finalize(codec::XzCompressor)
    free(codec.stream)
end

function TranscodingStreams.startproc(codec::XzCompressor, mode::Symbol, error::Error)
    ret = easy_encoder(codec.stream, codec.preset, codec.check)
    if ret != LZMA_OK
        error[] = ErrorException("xz error")
        return :error
    end
    return :ok
end

function TranscodingStreams.process(codec::XzCompressor, input::Memory, output::Memory, error::Error)
    stream = codec.stream
    stream.next_in = input.ptr
    stream.avail_in = input.size
    stream.next_out = output.ptr
    stream.avail_out = output.size
    ret = code(stream, input.size > 0 ? LZMA_RUN : LZMA_FINISH)
    Δin = Int(input.size - stream.avail_in)
    Δout = Int(output.size - stream.avail_out)
    if ret == LZMA_OK
        return Δin, Δout, :ok
    elseif ret == LZMA_STREAM_END
        return Δin, Δout, :end
    else
        error[] = ErrorException(lzma_error_string(ret))
        return Δin, Δout, :error
    end
end

# Decompressor Codec
# ==================

struct XzDecompressor <: TranscodingStreams.Codec
    stream::LZMAStream
    memlimit::Integer
    flags::UInt32
end

function Base.show(io::IO, codec::XzDecompressor)
    print(io, summary(codec), "(memlimit=$(codec.memlimit), flags=$(codec.flags))")
end

const DEFAULT_MEM_LIMIT = typemax(UInt64)

"""
    XzDecompressor(;memlimit=$(DEFAULT_MEM_LIMIT), flags=LZMA_CONCATENATED)

Create an xz decompression codec.

Arguments
---------
- `memlimit`: memory usage limit as bytes
- `flags`: decoder flags
"""
function XzDecompressor(;memlimit::Integer=DEFAULT_MEM_LIMIT, flags::UInt32=LZMA_CONCATENATED)
    if memlimit ≤ 0
        throw(ArgumentError("memlimit must be positive"))
    end
    # NOTE: flags are checked in liblzma
    return XzDecompressor(LZMAStream(), memlimit, flags)
end

const XzDecompressorStream{S} = TranscodingStream{XzDecompressor,S} where S<:IO

"""
    XzDecompressorStream(stream::IO; kwargs...)

Create an xz decompression stream (see `XzDecompressor` for `kwargs`).
"""
function XzDecompressorStream(stream::IO; kwargs...)
    x, y = splitkwargs(kwargs, (:memlimit, :flags))
    return TranscodingStream(XzDecompressor(;x...), stream; y...)
end


# Methods
# -------

function TranscodingStreams.initialize(codec::XzDecompressor)
    ret = stream_decoder(codec.stream, codec.memlimit, codec.flags)
    if ret != LZMA_OK
        lzmaerror(codec.stream, ret)
    end
    return
end

function TranscodingStreams.finalize(codec::XzDecompressor)
    free(codec.stream)
end

function TranscodingStreams.startproc(codec::XzDecompressor, mode::Symbol, error::Error)
    ret = stream_decoder(codec.stream, codec.memlimit, codec.flags)
    if ret != LZMA_OK
        error[] = ErrorException("xz error")
        return :error
    end
    return :ok
end

function TranscodingStreams.process(codec::XzDecompressor, input::Memory, output::Memory, error::Error)
    stream = codec.stream
    stream.next_in = input.ptr
    stream.avail_in = input.size
    stream.next_out = output.ptr
    stream.avail_out = output.size
    if codec.flags & LZMA_CONCATENATED != 0
        action = stream.avail_in > 0 ? LZMA_RUN : LZMA_FINISH
    else
        action = LZMA_RUN
    end
    ret = code(stream, action)
    Δin = Int(input.size - stream.avail_in)
    Δout = Int(output.size - stream.avail_out)
    if ret == LZMA_OK
        return Δin, Δout, :ok
    elseif ret == LZMA_STREAM_END
        return Δin, Δout, :end
    else
        error[] = ErrorException(lzma_error_string(ret))
        return Δin, Δout, :error
    end
end

# The liblzma Interfaces
# ======================

# Return code
const LZMA_OK                = Cint(0)
const LZMA_STREAM_END        = Cint(1)
const LZMA_NO_CHECK          = Cint(2)
const LZMA_UNSUPPORTED_CHECK = Cint(3)
const LZMA_GET_CHECK         = Cint(4)
const LZMA_MEM_ERROR         = Cint(5)
const LZMA_MEMLIMIT_ERROR    = Cint(6)
const LZMA_FORMAT_ERROR      = Cint(7)
const LZMA_OPTIONS_ERROR     = Cint(8)
const LZMA_DATA_ERROR        = Cint(9)
const LZMA_BUF_ERROR         = Cint(10)
const LZMA_PROG_ERROR        = Cint(11)

# Action code
const LZMA_RUN          = Cint(0)
const LZMA_SYNC_FLUSH   = Cint(1)
const LZMA_FULL_FLUSH   = Cint(2)
const LZMA_FULL_BARRIER = Cint(4)
const LZMA_FINISH       = Cint(3)

# Flag
const LZMA_TELL_NO_CHECK          = UInt32(0x01)
const LZMA_TELL_UNSUPPORTED_CHECK = UInt32(0x02)
const LZMA_TELL_ANY_CHECK         = UInt32(0x04)
const LZMA_IGNORE_CHECK           = UInt32(0x10)
const LZMA_CONCATENATED           = UInt32(0x08)

# Check
const LZMA_CHECK_NONE     = Cint(0)
const LZMA_CHECK_CRC32    = Cint(1)
const LZMA_CHECK_CRC64    = Cint(4)
const LZMA_CHECK_SHA256   = Cint(10)

mutable struct LZMAStream
    next_in::Ptr{UInt8}
    avail_in::Csize_t
    total_in::UInt64

    next_out::Ptr{UInt8}
    avail_out::Csize_t
    total_out::UInt64

    allocator::Ptr{Cvoid}

    internal::Ptr{Cvoid}

    reserved_ptr::NTuple{4,Ptr{Cvoid}}
    reserved_uint::NTuple{2,UInt64}
    reserved_size::NTuple{2,Csize_t}
    reserved_enum::NTuple{2,Cint}
end

function LZMAStream()
    return LZMAStream(
        C_NULL, 0, 0,
        C_NULL, 0, 0,
        C_NULL,
        C_NULL,
        (C_NULL, C_NULL, C_NULL, C_NULL),
        (0, 0), (0, 0),
        (0, 0))
end

function lzmaerror(stream::LZMAStream, code::Cint)
    error(lzma_error_string(code))
end

function lzma_error_string(code::Cint)
    return "lzma error: code = $(code)"
end

function easy_encoder(stream::LZMAStream, preset::Integer, check::Integer)
    return ccall(
        (:lzma_easy_encoder, liblzma),
        Cint,
        (Ref{LZMAStream}, UInt32, Cint),
        stream, preset, check)
end

function stream_decoder(stream::LZMAStream, memlimit::Integer, flags::Integer)
    return ccall(
        (:lzma_stream_decoder, liblzma),
        Cint,
        (Ref{LZMAStream}, UInt64, UInt32),
        stream, memlimit, flags)
end

function code(stream::LZMAStream, action::Integer)
    return ccall(
        (:lzma_code, liblzma),
        Cint,
        (Ref{LZMAStream}, Cint),
        stream, action)
end

function free(stream::LZMAStream)
    ccall((:lzma_end, liblzma), Cvoid, (Ref{LZMAStream},), stream)
end
